 ;************************;
 ; v2os fonts test.       ;
 ; program.               ;
 ; nasm ver.              ;
 ; Dos com file.          ;
 ;************************;
        org   100h	
        use16
        jmp   start
%INCLUDE "v2osfont.inc"
start:	

        mov  ax,1112h                                   ; Set 80x50 mode
	mov  bl,0
	int  10h
        
        call REPROGRAMFONT                              ; reprograms font for 80x50 mode
        call SETV2PALETTE                               ; palette,basicly color text/background

        mov   ah,3                                      ; hides cursor
	mov   bh,0
	int   10h   
      	or    ch,20h
	mov   ah,1
	int   10h

        call  Logo                                     ; we put logo on screen with this call
        mov   dh,5                                     ; this is moves were the cursor would be
        call  cursor
        mov   ah,0x09
        mov   dx,hello
        int   21h
       
        xor ax,ax
        int 16h
        
        mov ax,0x00003
        int 10h
        ret
 ;----------------------------------------------------;
 ; REPROGRAM FONT                                     ;
 ;----------------------------------------------------;

REPROGRAMFONT:

        push es

        mov  ax,ds
        mov  es,ax
        mov  bp,V2OSFONT
        mov  cx,00FFh
        xor  dx, dx
        mov  bx, 0800h
        mov  ax, 1100h
        int  10h                                        ; REPROGRAM FONT

        pop  es

        ret

 ;----------------------------------------------------;
 ; Logo                                               ;
 ;----------------------------------------------------;


Logo:
        pushad
        mov   ax,0xb800  
        mov   es,ax
        add   di,80*1*2
        add   di,4
        mov   dl,198               ; to me' this is the start of the logo in the font include.
        mov   dh,0x09              ; < this will be color ver
        mov   cx,3                 ; the logo seem to be 3 fonts down.
LogoVerLoop: 
        push  cx
        mov   cx,6                 ; 6 fonts across
        
        cld
LogoHorLoop:
        mov   ax,dx
        stosw
        inc   dl
        loop  LogoHorLoop
        add   di,(80-6)*2
        pop   cx
    
        loop  LogoVerLoop
        popad
        ret


 ;----------------------------------------------------;
 ; postion                                            ;
 ;----------------------------------------------------;

cursor:
        mov   ah,02h                                      ; moves the cursor
        mov   dl,1
        int   10h
        ret

 ;----------------------------------------------------;
 ; Clear screen                                       ;
 ;----------------------------------------------------;

cls:
        mov   ah,0Fh                                      ;cls screen
        int   10h
        mov   ah,0
        int   10h
        ret

 ;----------------------------------------------------;
 ; PALETTE                                            ;
 ;----------------------------------------------------;
PALETTE:
        ;LTH - the push/pop was changed to allow the code that calls this
        ;to be smaller by sharing values between calls
        pushad

        mov  dx,3c8h                                    ; Set palette index
        out  dx,al

        inc  dx                                         ; dx=3c9h

        mov  al,bl                                      ; Set Red-Value
        out  dx,al

        mov  al,bh                                      ; Set Green-Value
        out  dx,al

        mov  al,cl                                      ; Set Blue-Value
        out  dx,al

        popad
        ret

 ;----------------------------------------------------;
 ; Set a nifty color palette                          ;
 ;----------------------------------------------------;

SETV2PALETTE:

     ;   mov  ax,1003h                                   ; Clear background intensity bit 
     ;   mov  bl,0
    ;    int  10h

     ;   mov  al, 1
    ;    mov  bh,1
    ;    int  10h                                        ; SET BORDERCOLOR TO 1

     ;   xor  bx, bx
     ;   xor  cx, cx
     ;   call PALETTE                                    ; BORDERCLR

     ;   dec  al
     ;   mov  cl,16
     ;   call PALETTE                                    ; BACK CLR

     ;   mov  al,2
     ;   mov  bx, 3F3Fh
     ;   mov  cl,43
     ;   call PALETTE                                    ; EDIT TEXT

        mov  al,4
        mov  cl,63
        call PALETTE                                    ; HI TEXT

        mov  al, 5
        mov  bx, 3228h
        call PALETTE                                    ; LO TEXT

        mov  al,7
        CALL PALETTE                                    ; SAME

        mov  al,5
        mov  bx, 0032h
        mov  cl,0
        call PALETTE                                    ; ERROR TEXT

        mov  al,58
        mov  bx, 0A00h
        call PALETTE                                    ; DARKENED-GREY  (0Ah !

        inc  al
        mov  bh,40
        call PALETTE                                    ; LIGHTER-GREY  (0Bh !

        mov  al,56
        mov  bx, 1010h
        mov  cl,32
        call PALETTE                                    ; TOPBAR      ; 8 !


        mov  al,60
        mov  bx, 1818h
        mov  cl,48
        call PALETTE                                    ; DARK-TOPBAR   (0ch !


        ret

;**************************
;**************************

 hello db 'Hello bubach!',13,24h
